## mingw-w64-aws-c-http-0.10.10-1.src.tar.zst

=== tests/CMakeLists.txt ===
include(AwsTestHarness)
include(AwsLibFuzzer)
enable_testing()

file(GLOB TEST_HDRS "*.h")
file(GLOB TEST_SRC "*.c")
file(GLOB TESTS ${TEST_HDRS} ${TEST_SRC})

# Adds two test cases, where second one ends with "_one_byte_at_a_time"
macro(add_one_byte_at_a_time_test_set NAME)
    add_test_case("${NAME}")
    add_test_case("${NAME}_one_byte_at_a_time")
endmacro()

# Each h2_decoder test is run multiple ways. This adds each test case.
macro(add_h2_decoder_test_set NAME)
    add_test_case("${NAME}")
    add_test_case("${NAME}_one_byte_at_a_time")
endmacro()

add_test_case(test_http_error_code_is_retryable)

add_test_case(headers_add)
add_test_case(headers_add_array)
add_test_case(headers_set)
add_test_case(headers_erase_index)
add_test_case(headers_erase)
add_test_case(headers_erase_value)
add_test_case(headers_clear)
add_test_case(headers_get_all)
add_test_case(h2_headers_request_pseudos_get_set)
add_test_case(h2_headers_response_pseudos_get_set)

add_test_case(message_sanity_check)
add_test_case(message_request_method)
add_test_case(message_request_path)
add_test_case(message_response_status)
add_test_case(message_refcounts)
add_test_case(message_with_existing_headers)

add_test_case(h1_decoder_get_request)
add_test_case(h1_decoder_request_bad_version)
add_test_case(h1_decoder_response_unsupported_version)
add_test_case(h1_decoder_response_1_0)
add_test_case(h1_decoder_get_status_code)
add_test_case(h1_decoder_overflow_scratch_space)
add_test_case(h1_decoder_receive_request_headers)
add_test_case(h1_decoder_receive_response_headers)
add_test_case(h1_decoder_get_transfer_encoding_flags)
add_test_case(h1_decoder_body_unchunked)
add_test_case(h1_decoder_body_chunked)
add_test_case(h1_decoder_trailers)
add_test_case(h1_decoder_one_byte_at_a_time)
add_test_case(h1_decoder_messages_at_random_intervals)
add_test_case(h1_decoder_bad_requests_and_assert_failure)
add_test_case(h1_decoder_bad_responses_and_assert_failure)
add_test_case(h1_decoder_extraneous_buffer_data_ensure_not_processed)
add_test_case(h1_decoder_ignore_chunk_extensions)

add_test_case(h1_encoder_content_length_header)
add_test_case(h1_encoder_transfer_encoding_chunked_header)
add_test_case(h1_encoder_transfer_encoding_chunked_across_multiple_headers)
add_test_case(h1_encoder_case_insensitive_header_names)
add_test_case(h1_encoder_rejects_transfer_encoding_chunked_header_combined_with_content_length)
add_test_case(h1_encoder_rejects_transfer_encoding_header_without_chunked)
add_test_case(h1_encoder_transfer_encoding_chunked_header_with_multiple_encodings)
add_test_case(h1_encoder_rejects_transfer_encoding_header_when_chunked_not_final_encoding)
add_test_case(h1_encoder_rejects_transfer_encoding_header_not_ending_in_chunked)
add_test_case(h1_encoder_rejects_bad_method)
add_test_case(h1_encoder_rejects_missing_method)
add_test_case(h1_encoder_rejects_bad_path)
add_test_case(h1_encoder_rejects_missing_path)
add_test_case(h1_encoder_rejects_bad_header_name)
add_test_case(h1_encoder_rejects_bad_header_value)

add_test_case(h1_client_sanity_check)
add_test_case(h1_client_request_send_1liner)
add_test_case(h1_client_request_send_headers)
add_test_case(h1_client_request_send_body)
add_test_case(h1_client_request_send_body_chunked_and_streaming)
add_test_case(h1_client_request_send_body_chunked)
add_test_case(h1_client_request_send_chunked_trailer)
add_test_case(h1_client_request_forbidden_trailer)
add_test_case(h1_client_request_send_empty_chunked_trailer)
add_test_case(h1_client_request_send_large_body)
add_test_case(h1_client_request_send_large_body_chunked)
add_test_case(h1_client_request_send_large_body_chunked_and_streaming)
add_test_case(h1_client_request_send_large_head)
add_test_case(h1_client_request_send_empty_body_chunked_and_streaming)
add_test_case(h1_client_request_send_stalled_body_chunked_and_streaming)
add_test_case(h1_client_request_content_length_0_ok)
add_test_case(h1_client_request_waits_for_chunks)
add_test_case(h1_client_request_send_chunk_from_chunk_complete_callback)
add_test_case(h1_client_request_write_chunk_as_write_completes_regression)
add_test_case(h1_client_request_send_chunked_extensions)
add_test_case(h1_client_request_send_large_chunk_extensions)
add_test_case(h1_client_request_send_chunk_size_0_ok)
add_test_case(h1_client_request_send_chunk_size_0_with_extensions_ok)
add_test_case(h1_client_request_content_length_too_small_is_error)
add_test_case(h1_client_request_content_length_too_large_is_error)
add_test_case(h1_client_request_chunk_size_too_small_is_error)
add_test_case(h1_client_request_chunk_size_too_large_is_error)
add_test_case(h1_client_request_chunks_cancelled_by_channel_shutdown)
add_test_case(h1_client_request_send_multiple)
add_test_case(h1_client_request_send_multiple_chunked_encoding)
add_test_case(h1_client_request_close_header_ends_connection)
add_test_case(h1_client_request_close_header_with_pipelining)
add_test_case(h1_client_request_close_header_with_chunked_encoding_and_pipelining)
add_test_case(h1_client_stream_release_after_complete)
add_test_case(h1_client_stream_release_before_complete)
add_test_case(h1_client_response_get_1liner)
add_test_case(h1_client_response_get_headers)
add_test_case(h1_client_response_get_body)
add_test_case(h1_client_response_get_no_body_for_head_request)
add_test_case(h1_client_response_get_no_body_from_304)
add_test_case(h1_client_response_get_100)
add_test_case(h1_client_response_get_1_from_multiple_io_messages)
add_test_case(h1_client_response_get_multiple_from_1_io_message)
add_test_case(h1_client_response_with_bad_data_shuts_down_connection)
add_test_case(h1_client_response_with_too_much_data_shuts_down_connection)
add_test_case(h1_client_response_arrives_before_request_done_sending_is_ok)
add_test_case(h1_client_response_arrives_before_request_chunks_done_sending_is_ok)
add_test_case(h1_client_response_without_request_shuts_down_connection)
add_test_case(h1_client_response_close_header_ends_connection)
add_test_case(h1_client_response_close_header_with_pipelining)
add_test_case(h1_client_respects_stream_window)
add_test_case(h1_client_connection_window_with_buffer)
add_test_case(h1_client_connection_window_with_small_buffer)
add_test_case(h1_client_request_cancelled_by_channel_shutdown_before_response)
add_test_case(h1_client_request_cancelled_by_channel_shutdown_mid_response)
add_test_case(h1_client_multiple_requests_cancelled_by_channel_shutdown)
add_test_case(h1_client_new_request_fails_if_channel_shut_down)
add_test_case(h1_client_error_from_outgoing_body_callback_stops_decoder)
add_test_case(h1_client_error_from_incoming_headers_callback_stops_decoder)
add_test_case(h1_client_error_from_incoming_headers_done_callback_stops_decoder)
add_test_case(h1_client_error_from_incoming_body_callback_stops_decoder)
add_test_case(h1_client_close_from_off_thread_makes_not_open)
add_test_case(h1_client_close_from_on_thread_makes_not_open)
add_test_case(h1_client_unactivated_stream_cleans_up)
add_test_case(h1_client_new_request_allowed)
add_test_case(h1_client_midchannel_sanity_check)
add_test_case(h1_client_midchannel_read)
add_test_case(h1_client_midchannel_read_immediately)
add_test_case(h1_client_midchannel_read_with_small_downstream_window)
add_test_case(h1_client_midchannel_write)
add_test_case(h1_client_midchannel_write_continues_after_shutdown_in_read_dir)
add_test_case(h1_client_midchannel_requires_switching_protocols)
add_test_case(h1_client_switching_protocols_fails_pending_requests)
add_test_case(h1_client_switching_protocols_fails_subsequent_requests)
add_test_case(h1_client_switching_protocols_requires_downstream_handler)
add_test_case(h1_client_connection_close_before_request_finishes)
add_test_case(h1_client_stream_cancel)
add_test_case(h1_client_response_close_connection_before_request_finishes)
add_test_case(h1_client_response_first_byte_timeout_connection)
add_test_case(h1_client_response_first_byte_timeout_request_override)
add_test_case(h1_client_connection_close_before_request_finishes_with_buffer)
add_test_case(h1_client_connection_close_before_request_finishes_with_buffer_incomplete_response)
add_test_case(h1_client_connection_close_before_request_finishes_with_buffer_force_shutdown)
add_test_case(h1_client_connection_close_before_request_finishes_with_buffer_stream_cancel)

add_test_case(strutil_trim_http_whitespace)
add_test_case(strutil_is_http_token)
add_test_case(strutil_is_lowercase_http_token)
add_test_case(strutil_is_http_field_value)
add_test_case(strutil_is_http_reason_phrase)
add_test_case(strutil_is_http_request_target)
add_test_case(strutil_is_http_pseudo_header_name)

add_net_test_case(tls_download_medium_file_h1)
add_net_test_case(tls_download_medium_file_h2)
add_net_test_case(tls_download_shutdown_with_window_size_0)

add_test_case(websocket_decoder_sanity_check)
add_test_case(websocket_decoder_simplest_frame)
add_test_case(websocket_decoder_rsv)
add_test_case(websocket_decoder_data_frame)
add_test_case(websocket_decoder_stops_at_frame_end)
add_test_case(websocket_decoder_masking)
add_test_case(websocket_decoder_extended_length_2byte)
add_test_case(websocket_decoder_extended_length_8byte)
add_test_case(websocket_decoder_1byte_at_a_time)
add_test_case(websocket_decoder_fail_on_unknown_opcode)
add_test_case(websocket_decoder_fragmented_message)
add_test_case(websocket_decoder_fail_on_bad_fragmentation)
add_test_case(websocket_decoder_control_frame_cannot_be_fragmented)
add_test_case(websocket_decoder_utf8_text)
add_test_case(websocket_decoder_fail_on_bad_utf8_text)
add_test_case(websocket_decoder_fragmented_utf8_text)
add_test_case(websocket_decoder_fail_on_fragmented_bad_utf8_text)
add_test_case(websocket_decoder_on_frame_callback_can_fail_decoder)
add_test_case(websocket_decoder_on_payload_callback_can_fail_decoder)
add_test_case(websocket_encoder_sanity_check)
add_test_case(websocket_encoder_simplest_frame)
add_test_case(websocket_encoder_rsv)
add_test_case(websocket_encoder_data_frame)
add_test_case(websocket_encoder_fail_if_payload_exceeds_stated_length)
add_test_case(websocket_encoder_masking)
add_test_case(websocket_encoder_extended_length)
add_test_case(websocket_encoder_1_byte_at_a_time)
add_test_case(websocket_encoder_fragmented_message)
add_test_case(websocket_encoder_fragmentation_failure_checks)
add_test_case(websocket_encoder_payload_callback_can_fail_encoder)
add_test_case(websocket_handler_sanity_check)
add_test_case(websocket_handler_refcounting)
add_test_case(websocket_handler_send_frame)
add_test_case(websocket_handler_send_frame_off_thread)
add_test_case(websocket_handler_send_multiple_frames)
add_test_case(websocket_handler_send_huge_frame)
add_test_case(websocket_handler_send_payload_slowly)
add_test_case(websocket_handler_send_payload_with_pauses)
add_test_case(websocket_handler_sends_nothing_after_close_frame)
add_test_case(websocket_handler_send_frames_always_complete)
add_test_case(websocket_handler_send_one_io_msg_at_a_time)
add_test_case(websocket_handler_delayed_write_completion)
add_test_case(websocket_handler_send_halts_if_payload_fn_returns_false)
add_test_case(websocket_handler_shutdown_automatically_sends_close_frame)
add_test_case(websocket_handler_shutdown_handles_queued_close_frame)

# add_test_case(websocket_handler_shutdown_immediately_in_emergency) disabled until channel API exposes immediate shutdown
add_test_case(websocket_handler_shutdown_handles_unexpected_write_error)
add_test_case(websocket_handler_close_on_thread)
add_test_case(websocket_handler_close_off_thread)
add_test_case(websocket_handler_read_frame)
add_test_case(websocket_handler_read_multiple_frames)
add_test_case(websocket_handler_read_frames_split_across_io_messages)
add_test_case(websocket_handler_read_frames_complete_on_shutdown)
add_test_case(websocket_handler_read_halts_if_begin_fn_returns_false)
add_test_case(websocket_handler_read_halts_if_payload_fn_returns_false)
add_test_case(websocket_handler_read_halts_if_complete_fn_returns_false)
